"use strict";

exports.__esModule = true;
exports.default = void 0;

var _shipitUtils = _interopRequireDefault(require("shipit-utils"));

var _init = _interopRequireDefault(require("./init"));

var _fetch = _interopRequireDefault(require("./fetch"));

var _update = _interopRequireDefault(require("./update"));

var _publish = _interopRequireDefault(require("./publish"));

var _clean = _interopRequireDefault(require("./clean"));

var _finish = _interopRequireDefault(require("./finish"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Deploy task.
 * - deploy:fetch
 * - deploy:update
 * - deploy:publish
 * - deploy:clean
 * - deploy:finish
 */
var _default = shipit => {
  (0, _init.default)(shipit);
  (0, _fetch.default)(shipit);
  (0, _update.default)(shipit);
  (0, _publish.default)(shipit);
  (0, _clean.default)(shipit);
  (0, _finish.default)(shipit);

  _shipitUtils.default.registerTask(shipit, 'deploy', ['deploy:init', 'deploy:fetch', 'deploy:update', 'deploy:publish', 'deploy:clean', 'deploy:finish']);
};

exports.default = _default;